#macro cadre(A,B,r)
  #local X1= min ( A.x, B.x);
  #local X2= max ( A.x, B.x);
  #local Y1= min ( A.y, B.y);
  #local Y2= max ( A.y, B.y);
  #local Z1= min ( A.z, B.z);
  #local Z2= max ( A.z, B.z);
  
  union { 
    
    #if (X2>X1)
      cylinder { <X1,Y1,Z1>, <X2,Y1,Z1>, r}
      #if (Y2>Y1)
        cylinder { <X1,Y2,Z1>, <X2,Y2,Z1>, r} 
      #end  
      #if (Z2>Z1)
        cylinder { <X1,Y1,Z2>, <X2,Y1,Z2>, r} 
        #if (Y2>Y1)
          cylinder { <X2,Y2,Z2>, <X1,Y2,Z2>, r} 
        #end
      #end
    #end  
    
    #if (Y2>Y1)
      cylinder { <X1,Y1,Z1>, <X1,Y2,Z1>, r}  
      #if (X2>X1)
        cylinder { <X2,Y1,Z1>, <X2,Y2,Z1>, r} 
      #end
      #if (Z2>Z1)
        cylinder { <X1,Y1,Z2>, <X1,Y2,Z2>, r} 
        #if (X2>X1)
          cylinder { <X2,Y2,Z2>, <X2,Y1,Z2>, r} 
        #end
      #end
    #end    
    
    #if (Z2>Z1)
      cylinder { <X1,Y1,Z1>, <X1,Y1,Z2>, r} 
      #if (X2>X1)
        cylinder { <X2,Y1,Z1>, <X2,Y1,Z2>, r} 
      #end  
      # if (Y2>Y1)
        cylinder { <X1,Y2,Z1>, <X1,Y2,Z2>, r} 
        #if (X2>X1)
        cylinder { <X2,Y2,Z2>, <X2,Y2,Z1>, r}
        #end
      #end
    #end 
    
    intersection { 
      #if (X2>X1)
        cylinder { <X1-r,Y1,Z1>, <X2+r,Y1,Z1>, r}
      #end
      #if (Y2>Y1)
        cylinder { <X1,Y1-r,Z1>, <X1,Y2+r,Z1>, r} 
      #end
      #if (Z2>Z1)
        cylinder { <X1,Y1,Z1-r>, <X1,Y1,Z2+r>, r} 
      #end
      }    
      
    #if (X2>X1)  
      intersection { 
        #if (Y2>Y1)
          cylinder { <X2,Y1-r,Z1>, <X2,Y2+r,Z1>, r} 
        #end
        #if (Z2>Z1)
          cylinder { <X2,Y1,Z1-r>, <X2,Y1,Z2+r>, r} 
        #end
        cylinder { <X1-r,Y1,Z1>, <X2+r,Y1,Z1>, r}
        }    
    #end
      
    #if (Y2>Y1)  
      intersection { 
        #if (X2>X1)
          cylinder { <X1-r,Y2,Z1>, <X2+r,Y2,Z1>, r} 
        #end
        #if (Z2>Z1)
          cylinder { <X1,Y2,Z1-r>, <X1,Y2,Z2+r>, r} 
        #end
        cylinder { <X1,Y1-r,Z1>, <X1,Y2+r,Z1>, r} 
        }        
    #end
     
    #if (Z2>Z1)  
      intersection { 
        #if (Y2>Y1)
          cylinder { <X1,Y1-r,Z2>, <X1,Y2+r,Z2>, r} 
        #end
        #if (X2>X1)
          cylinder { <X1-r,Y1,Z2>, <X2+r,Y1,Z2>, r} 
        #end
        cylinder { <X1,Y1,Z1-r>, <X1,Y1,Z2+r>, r} 
        }        
    #end     
     
    #if ((X2>X1) & (Y2>Y1) & (Z2>Z1))
      intersection { 
        cylinder { <X2+r,Y2,Z2>, <X1-r,Y2,Z2>, r} 
        cylinder { <X2,Y2+r,Z2>, <X2,Y1-r,Z2>, r} 
        cylinder { <X2,Y2,Z2+r>, <X2,Y2,Z1-r>, r}
      }        
    #end
      
    #if ((Y2>Y1) & (Z2>Z1)) 
    intersection { 
      #if (X2>X1)
        cylinder { <X2+r,Y2,Z2>, <X1-r,Y2,Z2>, r} 
      #end
      cylinder { <X1,Y1-r,Z2>, <X1,Y2+r,Z2>, r} 
      cylinder { <X1,Y2,Z1-r>, <X1,Y2,Z2+r>, r} 
      }  
    #end
    
    #if ((X2>X1) & (Z2>Z1)) 
      intersection { 
        #if (Y2>Y1)
          cylinder { <X2,Y2+r,Z2>, <X2,Y1-r,Z2>, r} 
        #end
          cylinder { <X1-r,Y1,Z2>, <X2+r,Y1,Z2>, r} 
          cylinder { <X2,Y1,Z1-r>, <X2,Y1,Z2+r>, r} 
        }  
    #end
      
    #if ((X2>X1) & (Y2>Y1))  
    intersection { 
      #if (Z2>Z1)
        cylinder { <X2,Y2,Z2+r>, <X2,Y2,Z1-r>, r}
      #end
      cylinder { <X2,Y1-r,Z1>, <X2,Y2+r,Z1>, r}
      cylinder { <X1-r,Y2,Z1>, <X2+r,Y2,Z1>, r}
      }   
    #end
  }
#end
